import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
import shutil
import urllib2,urllib
import re
import extract
import downloader
import time
import sqlite3
import plugintools


USER_AGENT = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'
addon_id = 'plugin.program.kaosboxinstall'
ADDON = xbmcaddon.Addon(id=addon_id)
AddonID = 'plugin.program.kaosboxinstall'
AddonTitle = "KAOSbox Install"
dialog = xbmcgui.Dialog()
FANART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
ART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art/'))
VERSION = "4.1.0"
DBPATH = xbmc.translatePath('special://database')
TNPATH = xbmc.translatePath('special://thumbnails');
PATH = "KAOSbox Install"            
BASEURL = "http://www.kaosbox.tv"
H = 'http://'
EXCLUDES = ['plugin.program.kaosboxinstall','repository.kaosbox2']
thumbnailPath = xbmc.translatePath('special://thumbnails');
cachePath = os.path.join(xbmc.translatePath('special://home'), 'cache')
tempPath = xbmc.translatePath('special://temp')
addonPath = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'script.schoonmaak')
mediaPath = os.path.join(addonPath, 'media')
databasePath = xbmc.translatePath('special://database')
versietxt = xbmc.translatePath(os.path.join('special://home/userdata','versie.txt'))


def checkUpdate():
    if os.path.isfile(versietxt):
        file = open(versietxt, 'r')
        versie = file.read()
        file.close()
        return versie
    else:
        return 'onbekend'




class cacheEntry:
    def __init__(self, namei, pathi):
        self.name = namei
        self.path = pathi

def INDEX():
    addDir('KAOSbox Installeren',BASEURL,2,ART+'kaosboxdownload.png',FANART,'')
    addDir('Schone Installatie (Fabrieksinstellingen)','url',6,ART+'kaosboxdownload.png',FANART,'')
    addDir('','','',ART+'kaosboxdownload.png',FANART,'')
    addItem('[COLOR yellow]Over KAOSbox[/COLOR]',BASEURL,8,os.path.join(mediaPath, "kaosboxdownload.png"))
    setView('movies', 'MAIN')

def BUILDMENU():
    addItem('Wat is mijn Kodi Versie?',BASEURL,13,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('','','',os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('[COLOR red]- [/COLOR][COLOR yellow][ Kodi 16 Jarvis ][/COLOR][COLOR red] -[/COLOR]','',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Installatie KAOSbox 2017 Lite Edition','http://bit.ly/2kbr9hm',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Installatie XXX Pack (+18)','http://bit.ly/1pmtLvQ',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('','','',os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('[COLOR red]- [/COLOR][COLOR yellow][ Kodi 17 Krypton ][/COLOR][COLOR red] -[/COLOR]','',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Stap 1: Installatie KAOSbox 2017 Lite Edition','http://bit.ly/2l4nB5s',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Stap 2: Inschakelen Add-ons',BASEURL,4,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('','','',os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Stap 1: Installatie XXX Pack (+18)','http://bit.ly/1pmtLvQ',5,os.path.join(mediaPath, "kaosboxdownload.png"))
    addItem('Stap 2: Inschakelen XXX Add-ons',BASEURL,4,os.path.join(mediaPath, "kaosboxdownload.png"))
    setView('movies', 'MAIN')




def ADDONSENABLE():
    conn = sqlite3.connect(xbmc.translatePath("special://database/Addons27.db"))
    c = conn.cursor()
    c.execute("UPDATE installed SET enabled = 1 WHERE addonID NOT LIKE '%audiodecoder.%' AND addonID NOT LIKE '%inputstream.%' AND addonID NOT LIKE '%pvr.%' AND addonID NOT LIKE '%screensaver.%' AND addonID NOT LIKE '%visualization.%';")
    conn.commit()
    conn.close()
    dialog = xbmcgui.Dialog()
    dialog.ok("KAOSbox Install", "Kodi moet worden herstart om de insallatie met succes af te ronden (force close). Klik op OK om Kodi te sluiten.")
    os._exit(1)
  

def OPEN_URL(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link

def KODIVERSION(url): xbmc_version=xbmc.getInfoLabel("System.BuildVersion"); version=xbmc_version[:4]; print version; dialog=xbmcgui.Dialog(); dialog.ok(AddonTitle, "Kodi Versie is : %s" % version)




#################################
####### POPUP TEXT BOXES ########
#################################

def TextBoxes(heading,announce):
  class TextBox():
    WINDOW=10147
    CONTROL_LABEL=1
    CONTROL_TEXTBOX=5
    def __init__(self,*args,**kwargs):
      xbmc.executebuiltin("ActivateWindow(%d)" % (self.WINDOW, )) # activate the text viewer window
      self.win=xbmcgui.Window(self.WINDOW) # get window
      xbmc.sleep(500) # give window time to initialize
      self.setControls()
    def setControls(self):
      self.win.getControl(self.CONTROL_LABEL).setLabel(heading) # set heading
      try: f=open(announce); text=f.read()
      except: text=announce
      self.win.getControl(self.CONTROL_TEXTBOX).setText(str(text))
      return
  TextBox()

def facebook():
    TextBoxes('KAOSbox Install', '[COLOR=red]KAOSbox - Home Entertainment Redefined[/COLOR]\nEindelijk een gratis no-nonsense plug en play media systeem voor je Raspberry Pi, Hummingboard/Cubox-i, Android en Windows media box!\n\nVoor meer informatie kijk op www.kaosbox.tv')

        

def WIZARD(name,url,description):
    path = xbmc.translatePath(os.path.join('special://home/addons','packages'))
    lib=os.path.join(path, name+'.zip')
    try:
       os.remove(lib)
    except:
       pass
    downloader.download(url, lib)
    if os.path.exists(lib):
        addonfolder = xbmc.translatePath(os.path.join('special://','home'))
        time.sleep(2)
        dp = xbmcgui.DialogProgress()
        dp.create("Uw systeem wordt nu bijgewerkt.",'', 'Wacht geduldig af tot volgende venster verschijnt.')
        dp.update(0,"", "ZIP wordt uitgepakt - even geduld")
        print '======================================='
        print addonfolder
        print '======================================='
        extract.all(lib,addonfolder,dp)
        dp.close()
        try: os.remove(lib)
        except: pass        
        dialog = xbmcgui.Dialog()
        dialog.ok("KAOSbox Install", "Kodi moet worden herstart om de insallatie met succes af te ronden (force close). Klik op OK om Kodi te sluiten.")
        os._exit(1)

  
      
    

def FRESHSTART(params):
    plugintools.log("freshstart.main_list "+repr(params)); yes_pressed=plugintools.message_yes_no(AddonTitle,"Wil je de standaard instellingen terug zetten van je Kodi installatie?")
    if yes_pressed:
        addonPath=xbmcaddon.Addon(id=AddonID).getAddonInfo('path'); addonPath=xbmc.translatePath(addonPath); 
        xbmcPath=os.path.join(addonPath,"..",".."); xbmcPath=os.path.abspath(xbmcPath); plugintools.log("freshstart.main_list xbmcPath="+xbmcPath); failed=False
        try:
            for root, dirs, files in os.walk(xbmcPath,topdown=True):
                dirs[:] = [d for d in dirs if d not in EXCLUDES]
                for name in files:
                    try: os.remove(os.path.join(root,name))
                    except:
                        if name not in ["Addons15.db","MyVideos75.db","Textures13.db","xbmc.log"]: failed=True
                        plugintools.log("Error removing "+root+" "+name)
                for name in dirs:
                    try: os.rmdir(os.path.join(root,name))
                    except:
                        if name not in ["Database","userdata"]: failed=True
                        plugintools.log("Error removing "+root+" "+name)
            if not failed: plugintools.log("freshstart.main_list All user files removed, you now have a clean install"); plugintools.message(AddonTitle,"Schone Installatie is klaar, je hebt nu een verse Kodi configuratie met KAOSbox Install. Herstart nu je box!")
            else: plugintools.log("freshstart.main_list User files partially removed"); plugintools.message(AddonTitle,"Schone Installatie is klaar, je hebt nu een verse Kodi configuratie met KAOSbox Install. Herstart nu je box!")
        except: plugintools.message(AddonTitle,"Problem found","Your settings has not been changed"); import traceback; plugintools.log(traceback.format_exc()); plugintools.log("freshstart.main_list NOT removed")
        plugintools.add_item(action="",title="Kodi Sluiten",folder=False)
    else: plugintools.message(AddonTitle,"Er is geen schone installatie gedaan."); plugintools.add_item(action="",title="Klaar",folder=False)



def addItem(name,url,mode,iconimage):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setInfo( type="Video", infoLabels={ "Title": name } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
	return ok

          
        
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

N = base64.decodestring('')
T = base64.decodestring('L2FkZG9ucy50eHQ=')
B = base64.decodestring('')
F = base64.decodestring('')
def addDir(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        if mode==5 :
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        else:
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok
      
                      
params=get_params()
url=None
name=None
mode=None
iconimage=None
fanart=None
description=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:        
        mode=int(params["mode"])
except:
        pass
try:        
        fanart=urllib.unquote_plus(params["fanart"])
except:
        pass
try:        
        description=urllib.unquote_plus(params["description"])
except:
        pass
        
        
print str(PATH)+': '+str(VERSION)
print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "IconImage: "+str(iconimage)


def setView(content, viewType):
    # set content type so library shows more views and info
    if content:
        xbmcplugin.setContent(int(sys.argv[1]), content)
    if ADDON.getSetting('auto-view')=='true':
        xbmc.executebuiltin("Container.SetViewMode(%s)" % ADDON.getSetting(viewType) )
        

if mode==None or url==None or len(url)<1:
        INDEX()

elif mode==2:
        BUILDMENU()

		
elif mode==4:
        ADDONSENABLE()
	
elif mode==5:
        WIZARD(name,url,description)

elif mode==6:        
	FRESHSTART(params)

	
elif mode==8:
       facebook()

	
elif mode==13:        
	KODIVERSION(url)
	
        
xbmcplugin.endOfDirectory(int(sys.argv[1]))